function [] = min_max_gloss(filename)	

	data = dlmread(filename,',',1,0);

	sData = size(data);
	nbHits = sData(1)/(4*4*6); % number of hits per input (sharpness,contrast,brush)
	nbHits
	
	%--- gather the data, for each input sharpness, contrast and brush size ---%
	data_sharpness = zeros(4,4,6,nbHits);
	data_contrast = zeros(4,4,6,nbHits);
	ind = ones(4,4,6);
	for(i=1:sData(1))
	    if(data(i,4) == 3 | data(i,4) == 6)
                brush_indice = data(i,4)/3+1;
            else
                brush_indice = data(i,4)/4+1;
            end
		true_sharpness = data(i,2);
		true_indice_s = (round((true_sharpness-0.044)/0.017))/3+1;
		true_contrast = data(i,3);
		true_c = (true_contrast+0.1)^(1/3)-(0.1)^(1/3);
		true_indice_c = (round((true_c-0.046)/0.031))/2+1;
		user_sharpness = data(i,5);
		user_contrast = data(i,6);
		
		data_sharpness(true_indice_s,true_indice_c,brush_indice,ind(true_indice_s,true_indice_c,brush_indice)) = user_sharpness;
		data_contrast(true_indice_s,true_indice_c,brush_indice,ind(true_indice_s,true_indice_c,brush_indice)) = user_contrast;
		ind(true_indice_s,true_indice_c,brush_indice) = ind(true_indice_s,true_indice_c,brush_indice)+1;
	end
		
	ind(:,:,:) = ind(:,:,:) - 1
	true_sharpness = [0.044 0.095 0.146 0.197];
	true_contrast = [0.0328 0.0873 0.1551 0.2374];
	
		
	%--- location in gloss space ---%
	d_origin = 1-0.231;  % iso-gloss computed as the distance to the origin of our data (c=0.015, d=0.769)
	c_origin = 0.015;
	
	true_d = 1-true_sharpness - d_origin;
	true_c = (true_contrast+0.1).^(1/3) - (0.1)^(1/3) - c_origin;
	
	data_d = 1-data_sharpness - d_origin;
	data_c = (data_contrast+0.1).^(1/3) - (0.1)^(1/3) - c_origin;

	data_gloss = sqrt(data_c.*data_c + (1.78*data_d).*(1.78*data_d));
	
	%avg_data_d = mean(data_d,4);
	%avg_data_c = mean(data_c,4);
	
	
	for(s=1:6) %for each brush size
		brush_size = (s-1)*4;
		brush_size

		minG = 5;
		maxG = 0;
		std_gloss = 0;
		
		for(i=1:4) %for each input sharpness
			for(j=1:4) %for each input contrast
				clear gloss_curr;
				gloss_curr = data_gloss(i,j,s,1:ind(i,j,s));

				avg_gloss = mean(gloss_curr);

				std_gloss = std_gloss+std(gloss_curr);

				if(avg_gloss<minG)
					minG = avg_gloss;
				end;

				if(avg_gloss>maxG)
					maxG = avg_gloss;
				end;
			end
		end
	
		minG
		maxG
		std_gloss/16

	end

	