function [] = plot_2d_mapping(filename,style,user)	

	data = dlmread(filename,',',1,0);

	sData = size(data);
	nbHits = sData(1)/(4*4*6); % number of hits per input (sharpness,contrast,brush)
	
	
	%--- gather the data, for each input sharpness, contrast and brush size ---%
	data_sharpness = zeros(4,4,6,nbHits);
	data_contrast = zeros(4,4,6,nbHits);
	ind = ones(4,4,6);
	for(i=1:sData(1))
            if(data(i,4) == 3 | data(i,4) == 6)
                brush_indice = data(i,4)/3+1;
            else
                brush_indice = data(i,4)/4+1;
            end
			true_sharpness = data(i,2);
			true_indice_s = (round((true_sharpness-0.044)/0.017))/3+1;
			true_contrast = data(i,3);
			true_c = (true_contrast+0.1)^(1/3)-(0.1)^(1/3);
			true_indice_c = (round((true_c-0.046)/0.031))/2+1;
			user_sharpness = data(i,5);
			user_contrast = data(i,6);
		
			data_sharpness(true_indice_s,true_indice_c,brush_indice,ind(true_indice_s,true_indice_c,brush_indice)) = user_sharpness;
			data_contrast(true_indice_s,true_indice_c,brush_indice,ind(true_indice_s,true_indice_c,brush_indice)) = user_contrast;
			ind(true_indice_s,true_indice_c,brush_indice) = ind(true_indice_s,true_indice_c,brush_indice)+1;
	end
		
	ind(:,:,:) = ind(:,:,:) - 1
	true_sharpness = [0.044 0.095 0.146 0.197];
	true_contrast = [0.0328 0.0873 0.1551 0.2374];
	
		
	%--- location in gloss space ---%
	d_origin = 1-0.231;  % iso-gloss computed as the distance to the origin of our data (c=0.015, d=0.769)
	c_origin = 0.015;
	
	true_d = 1-true_sharpness - d_origin;
	true_c = (true_contrast+0.1).^(1/3) - (0.1)^(1/3) - c_origin;
	
	data_d = 1-data_sharpness - d_origin;
	data_c = (data_contrast+0.1).^(1/3) - (0.1)^(1/3) - c_origin;
	

	colormap4 = [
	[217/255 240/255 163/255];[173/255 221/255 142/255];[120/255 198/255 121/255];[65/255 171/255 93/255];[35/255 132/255 67/255];[0/255 90/255 50/255]; %green
	[12/255 44/255 132/255];[34/255 94/255 168/255];[29/255 145/255 192/255];[65/255 182/255 196/255];[127/255 205/255 187/255];[199/255 233/255 180/255]; %blue
	[252/255 197/255 192/255];[250/255 159/255 181/255];[247/255 104/255 161/255]; [221/255 52/255 151/255];[174/255 1/255 126/255];[122/255 1/255 119/255];%purple 
	[254/255 217/255 118/255];[254/255 178/255 76/255];[253/255 141/255 60/255];[252/255 78/255 42/255];[227/255 26/255 28/255]; [177/255 0/255 38/255]; %red  
	];
	
	colormap1 = [ [26/255 152/255 80/255]; [145/255 207/255 96/255]; [217/255 239/255 139/255]; [254/255 224/255 139/255]; [252/255 141/255 89/255]; [215/255 48/255 39/255] ];

	
	for(s=1:5) %for each brush size
		figMap = figure();
		%--- iso-lines ---%
		D = 0.1;
		c = 0.0:0.01:0.1;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d+d_origin,c+c_origin,'--k');hold on;
		D = 0.2;
		c = 0.0:0.01:0.2;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d+d_origin,c+c_origin,'--k');hold on;
		D = 0.3;
		c = 0.0:0.01:0.3;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d+d_origin,c+c_origin,'--k');hold on;
		D = 0.4;
		c = 0.0:0.01:0.4;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d+d_origin,c+c_origin,'--k');hold on;
			
		for(i=1:4) %for each input sharpness
			for(j=1:4) %for each input contrast
				%--- draw elipse of the covariance matrices ---%
				% PCA
				clear data_curr;
				data_curr(1,:) = data_d(i,j,s,1:ind(i,j,s));
				data_curr(2,:) = data_c(i,j,s,1:ind(i,j,s));
				[data_eigenvect, data_score, data_eigenval] = princomp(data_curr');
				data_std_dev = sqrt(data_eigenval);
				vec1 = data_eigenvect(:,1)*data_std_dev(1);
				vec2 = data_eigenvect(:,2)*data_std_dev(2);
				if(data_std_dev(2)>data_std_dev(1))	%actually this should never occur
					vtemp = vec1;
					stdtemp = data_std_dev(1);
					vec1 = vec2;
					data_std_dev(1) = data_std_dev(2);
					vec2 = vtemp;
					data_std_dev(2) = stdtemp;
					test = -1
				end
				
				colorInd = (i-1)*6+j+1;
				ellipse_angle = atan2(vec1(2),vec1(1));
				h = ellipsedraw(data_std_dev(1),data_std_dev(2),mean(data_curr(1,:))+d_origin,mean(data_curr(2,:))+c_origin,ellipse_angle);hold on;
				set(h,'LineWidth',1,'Color',colormap4(colorInd,:));
			end
		end
	
		%--- axis and label ---%
		axis equal;
		axis([d_origin d_origin+0.25 c_origin c_origin+0.25]);
		xlabel('Perceptual sharpness d', 'FontSize', 28);
		ylabel('Perceptual contrast c', 'FontSize', 28);
		set(gca,'FontSize',24);
		% Change the aspect ratio of the plot
		%stitle = sprintf('Mapping between true gloss and perceived gloss\n Brush size = %d',(s-1)*4);
		%title(stitle);
		
		filename = sprintf(strcat('../data_lab/plots/',style,'/',user,'/distributions_%d.pdf'),(s-1)*4)
		saveas(figMap,filename);
		
	end

	
	
	for(s=1:5) %for each brush size
		figMap = figure();
		%--- iso-lines ---%
		D = 0.1;
		c = 0.0:0.01:0.1;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d+d_origin,c+c_origin,'--k');hold on;
		D = 0.2;
		c = 0.0:0.01:0.2;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d+d_origin,c+c_origin,'--k');hold on;
		D = 0.3;
		c = 0.0:0.01:0.3;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d+d_origin,c+c_origin,'--k');hold on;
		D = 0.4;
		c = 0.0:0.01:0.4;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d+d_origin,c+c_origin,'--k');hold on;
			
		for(i=1:4) %for each input sharpness
			for(j=1:4) %for each input contrast
			
				%draw an arrow from the true sharpness/contrast to the average perceived sharpness/contrast
				clear data_curr;
				data_curr(1,:) = data_d(i,j,s,1:ind(i,j,s));
				data_curr(2,:) = data_c(i,j,s,1:ind(i,j,s));
				
				diff_sharpness = mean(data_curr(1,:)) - true_d(i);
				diff_contrast = mean(data_curr(2,:)) - true_c(j);

				
				colorInd = (i-1)*6+j+1;
				quiver(true_d(i)+d_origin,true_c(j)+c_origin,diff_sharpness,diff_contrast,'LineWidth',1,'Color',colormap4(colorInd,:),'MaxHeadSize',0.4);hold on;
				
			end
		end
	
		%--- axis and label ---%
		axis equal;
		%set(gca,'DataAspectRatio',[1 1.7 1])
		axis([d_origin d_origin+0.25 c_origin c_origin+0.25]);
		xlabel('Perceptual sharpness d', 'FontSize', 28);
		ylabel('Perceptual contrast c', 'FontSize', 28);
		set(gca,'FontSize',24)
		% Change the aspect ratio of the plot
		%stitle = sprintf('Mapping between true gloss and perceived gloss\n Brush size = %d',(s-1)*4);
		%title(stitle);
		
		filename = sprintf(strcat('../data_lab/plots/',style,'/',user,'/mapping_%d.pdf'),(s-1)*4)
		saveas(figMap,filename);
		
	end
	
