function [] = plot_sharpness_vs_contrast(filename,sharpness_index)	

	data = dlmread(filename,',',1,0);

	sData = size(data);
	nbHits = sData(1)/(4*4*6); % number of hits per input (sharpness,contrast,brush)
	
	%threshUser = 15;
	%threshOutlier = 0.2;
	%[nbTrialUser,nbOutlier,percentageOutlier] = user_analysis(data,textdata);
	
	%--- gather the data, for each input sharpness, contrast and brush size ---%
	data_sharpness = zeros(4,4,6,nbHits);
	data_contrast = zeros(4,4,6,nbHits);
	ind = ones(4,4,6);
	for(i=1:sData(1))
		%if(nbTrialUser.(char(textdata(i+1,1)))>=threshUser && percentageOutlier.(char(textdata(i+1,1)))<threshOutlier)
		if(data(i,4) == 3 | data(i,4) == 6)
		    brush_indice = data(i,4)/3+1;
		else
		    brush_indice = data(i,4)/4+1;
		end
			
			true_sharpness = data(i,2);
			true_indice_s = (round((true_sharpness-0.044)/0.017))/3+1;
			true_contrast = data(i,3);
			true_c = (true_contrast+0.1)^(1/3)-(0.1)^(1/3);
			true_indice_c = (round((true_c-0.046)/0.031))/2+1;
			user_sharpness = data(i,5);
			user_contrast = data(i,6);
		
			data_sharpness(true_indice_s,true_indice_c,brush_indice,ind(true_indice_s,true_indice_c,brush_indice)) = user_sharpness;
			data_contrast(true_indice_s,true_indice_c,brush_indice,ind(true_indice_s,true_indice_c,brush_indice)) = user_contrast;
			ind(true_indice_s,true_indice_c,brush_indice) = ind(true_indice_s,true_indice_c,brush_indice)+1;
		%end
	end
		
	ind(:,:,:) = ind(:,:,:) - 1
	true_sharpness = [0.044 0.095 0.146 0.197];
	true_contrast = [0.0328 0.0873 0.1551 0.2374];
	
		
	%--- location in gloss space ---%
	d_origin = 1-0.231;  % iso-gloss computed as the distance to the origin of our data (c=0.015, d=0.769)
	c_origin = 0.015;
	
	true_d = 1-true_sharpness - d_origin;
	true_c = (true_contrast+0.1).^(1/3) - (0.1)^(1/3) - c_origin;
	
	data_d = 1-data_sharpness - d_origin;
	data_c = (data_contrast+0.1).^(1/3) - (0.1)^(1/3) - c_origin;
	
	%avg_data_d = mean(data_d,4);
	%avg_data_c = mean(data_c,4);
	

	colormap4 = [
	[217/255 240/255 163/255];[173/255 221/255 142/255];[120/255 198/255 121/255];[65/255 171/255 93/255];[35/255 132/255 67/255];[0/255 90/255 50/255]; %green
	[12/255 44/255 132/255];[34/255 94/255 168/255];[29/255 145/255 192/255];[65/255 182/255 196/255];[127/255 205/255 187/255];[199/255 233/255 180/255]; %blue
	[252/255 197/255 192/255];[250/255 159/255 181/255];[247/255 104/255 161/255]; [221/255 52/255 151/255];[174/255 1/255 126/255];[122/255 1/255 119/255];%purple 
	[254/255 217/255 118/255];[254/255 178/255 76/255];[253/255 141/255 60/255];[252/255 78/255 42/255];[227/255 26/255 28/255]; [177/255 0/255 38/255]; %red  
	];
	
	colormap1 = [ [26/255 152/255 80/255]; [145/255 207/255 96/255]; [217/255 239/255 139/255]; [254/255 224/255 139/255]; [252/255 141/255 89/255]; [215/255 48/255 39/255] ];
	
	
    i=sharpness_index; %fix the sharpness
	s=1; %no brush
		figMap = figure();
		
		for(j=1:4) %for each input contrast
			
				clear data_curr;
				data_curr(1,:) = data_d(i,j,s,1:ind(i,j,s));
				%data_curr(2,:) = data_c(i,j,s,1:ind(i,j,s));
				
                d_curr = data_curr(1,:)+d_origin;
                c_curr = true_c(j)+c_origin;
                
                y = mean(d_curr);
                e = std(d_curr);
                
                hh = herrorbar(y,c_curr,e,'x');
                set(hh,'Color',colormap4(9,:))
                hold on;
                plot([true_d(i)+d_origin true_d(i)+d_origin],[c_origin c_origin+0.25],'Color',colormap4(13,:));
		end
	
		%--- axis and label ---%
		axis equal;
		%set(gca,'DataAspectRatio',[1 1.7 1])
		axis([d_origin d_origin+0.25 c_origin c_origin+0.25]);
		xlabel('Perceptual sharpness d', 'FontSize', 28);
		ylabel('Perceptual contrast c', 'FontSize', 28);
		set(gca,'FontSize',24)
		% Change the aspect ratio of the plot
		%stitle = sprintf('Mapping between true gloss and perceived gloss\n Brush size = %d',(s-1)*4);
		%title(stitle);
		
		filename = sprintf('../data_lab/plots/independence/sharpness_vs_contrast_d%f.pdf',true_d(i)+d_origin);
		saveas(figMap,filename);
        
        clear S1;
        clear S2;
        clear S3;
        clear S4;
        S1(:,:) = data_d(i,1,s,1:ind(i,1,s));
        S2(:,:) = data_d(i,2,s,1:ind(i,2,s));
        S3(:,:) = data_d(i,3,s,1:ind(i,3,s));
        S4(:,:) = data_d(i,4,s,1:ind(i,4,s));
        S = [S1' S2' S3' S4']+d_origin;
        C = [true_c(1)*ones(1,ind(i,1,s))  true_c(2)*ones(1,ind(i,2,s)) true_c(3)*ones(1,ind(i,3,s)) true_c(4)*ones(1,ind(i,4,s))] + c_origin;
        
        %figure();
        %plot(S,C,'x');
		%axis equal;
		%axis([d_origin d_origin+0.25 c_origin c_origin+0.25]);
		%xlabel('Perceptual sharpness d', 'FontSize', 28);
		%ylabel('Perceptual contrast c', 'FontSize', 28);
		%set(gca,'FontSize',24)
        
        [r,p] = corrcoef(S,C);  % Compute sample correlation and p-values.
        r
        p
		
	
	