function [] = solve_mapping_2d(filename)	
	data = dlmread(filename,',',1,0);

	sData = size(data);
	nbHits = sData(1)/(4*4*6); % number of hits per input (sharpness,contrast,brush)
	
	%--- gather the data, for each input sharpness, contrast and brush size ---%
	% data
	data_sharpness = zeros(4,4,6,nbHits);
	data_contrast = zeros(4,4,6,nbHits);
	ind = ones(4,4,6);
	
	% fitting matrices
	fit_order = 1;
	A = zeros(sData(1)/6,(fit_order+1)*(fit_order+2)/2,6);
	xc = zeros(sData(1)/6,6);
	xd = zeros(sData(1)/6,6);
	ind_fit = [0 0 0 0 0 0];

	si = [1 2 3 5];
	%si = [1 2 3 3];

	avg_c = zeros(6);
	avg_d = zeros(6);
	nbtot = zeros(6);
	
	for(i=1:sData(1))
		if(data(i,4) == 3 | data(i,4) == 6)
			brush_indice = data(i,4)/3+1;
		else
			brush_indice = data(i,4)/4+1;
		end
		
		true_sharpness = data(i,2);
		true_d = 1-true_sharpness;
		true_indice_s = (round((true_sharpness-0.044)/0.017))/3+1;
		
		true_contrast = data(i,3);
		true_c = (true_contrast+0.1)^(1/3)-(0.1)^(1/3);
		true_indice_c = (round((true_c-0.046)/0.031))/2+1;
		
		user_sharpness = data(i,5);
		user_d = 1-user_sharpness;
		user_contrast = data(i,6);
		user_c = (user_contrast+0.1).^(1/3) - (0.1)^(1/3);

		avg_c(brush_indice) = avg_c(brush_indice)+user_c;
		avg_d(brush_indice) = avg_d(brush_indice)+user_d;
		nbtot(brush_indice) = nbtot(brush_indice)+1;
		
		ind_fit(brush_indice) = ind_fit(brush_indice)+1;
		ind_poly = 0;
		for(m=1:fit_order+1)
			for(n=1:fit_order+1-(m-1))
				ind_poly = ind_poly+1;
				A(ind_fit(brush_indice),ind_poly, brush_indice) = (true_c^(m-1)) * (true_d^(n-1)) ;
			end
		end
		xc(ind_fit(brush_indice),brush_indice) = user_c;%-true_c;
		xd(ind_fit(brush_indice),brush_indice) = user_d;%-true_d;
		
		data_sharpness(true_indice_s,true_indice_c,brush_indice,ind(true_indice_s,true_indice_c,brush_indice)) = user_sharpness;
		data_contrast(true_indice_s,true_indice_c,brush_indice,ind(true_indice_s,true_indice_c,brush_indice)) = user_contrast;
		ind(true_indice_s,true_indice_c,brush_indice) = ind(true_indice_s,true_indice_c,brush_indice)+1;
	end

	avg_c = avg_c./nbtot;
	avg_d = avg_d./nbtot;
	
	% solve the system
	for(i=1:4) %for each brush size
		s = si(i);
		A_tmp(:,:) = A(:,:,s);
		xc_tmp = xc(:,s);
		xd_tmp = xd(:,s);
		mapping_c(:,s) = A_tmp\xc_tmp;
		mapping_d(:,s) = A_tmp\xd_tmp;

		s
		%mapping_c(:,s)
		%mapping_d(:,s)

		summary = sprintf('& $%f$ & $%f$  & $%f$ & $%f$ & $%f$ & $%f$',mapping_c(3,s),mapping_c(2,s),mapping_c(1,s),mapping_d(3,s),mapping_d(2,s),mapping_d(1,s));
		summary
	end
	
	
	
	%compute the matrices and offset for the mapping
	alpha = 0.01;
	for(i=1:4) %for each brush size
		s = si(i);
		M(s,1,:) = [mapping_c(3,s) mapping_c(2,s)];
		M(s,2,:) = [mapping_d(3,s) mapping_d(2,s)];
		u(s,1) = mapping_c(1,s);
		u(s,2) = mapping_d(1,s);
		
		M_curr(:,:) = M(s,:,:);
		[U,S,V] = svd(M_curr);
		%Minv(s,:,:) = inv(M_curr+alpha*eye(2));
		%Minv(s,:,:) = V*inv(S+alpha*eye(2))*(U');
		Minv(s,:,:) = inv(M_curr);
	end
	
	
	%--- fitting error ---%
	error_c = 0;
	error_d = 0;
	sstot_c = 0;
	sstot_d = 0;
	for(i=1:sData(1))
		if(data(i,4) == 3 | data(i,4) == 6)
			brush_indice = data(i,4)/3+1;
		else
			brush_indice = data(i,4)/4+1;
		end
		
		true_sharpness = data(i,2);
		true_d = 1-true_sharpness;
		true_indice_s = (round((true_sharpness-0.044)/0.017))/3+1;
		
		true_contrast = data(i,3);
		true_c = (true_contrast+0.1)^(1/3)-(0.1)^(1/3);
		true_indice_c = (round((true_c-0.046)/0.031))/2+1;
		
		user_sharpness = data(i,5);
		user_d = 1-user_sharpness;
		user_contrast = data(i,6);
		user_c = (user_contrast+0.1).^(1/3) - (0.1)^(1/3);
		
		c_predicted = 0;
		d_predicted = 0;
		ind_poly = 0;
		for(m=1:fit_order+1)
			for(n=1:fit_order+1-(m-1))
				ind_poly = ind_poly+1;
				c_predicted = c_predicted + mapping_c(ind_poly, brush_indice) * ( (true_c^(m-1)) * (true_d^(n-1)) );
				d_predicted = d_predicted + mapping_d(ind_poly, brush_indice) * ( (true_c^(m-1)) * (true_d^(n-1)) );
			end
		end
							
		
		error_c = error_c + (user_c-c_predicted)*(user_c-c_predicted);
		error_d = error_d + (user_d-d_predicted)*(user_d-d_predicted);

		sstot_c = sstot_c + (avg_c(brush_indice)-user_c)*(avg_c(brush_indice)-user_c);
		sstot_d = sstot_d + (avg_d(brush_indice)-user_d)*(avg_d(brush_indice)-user_d);
	end
	
	
	
	
	%--- location in gloss space ---%
	
	true_sharpness = [0.044 0.095 0.146 0.197];
	true_contrast = [0.0328 0.0873 0.1551 0.2374];
	
	d_origin = 1-0.24;  % iso-gloss computed as the distance to the origin of our data (c=0.01, d=0.76)
	c_origin = 0.01;
	true_d = 1-true_sharpness - d_origin;
	true_c = (true_contrast+0.1).^(1/3) - (0.1)^(1/3) - c_origin;
	
	data_d = 1-data_sharpness - d_origin;
	data_c = (data_contrast+0.1).^(1/3) - (0.1)^(1/3) - c_origin;
	
	avg_data_d = mean(data_d,4);
	avg_data_c = mean(data_c,4);
	
	res = 0;
	nbRes = 0;
	for(i=1:4) %for each brush size
		s = si(i);
		%--- plot forward mapping ---
		
		figMap = figure();
		%--- iso-lines ---%
		D = 0.1;
		c = 0.0:0.01:0.1;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d,c,'--k');hold on;
		D = 0.2;
		c = 0.0:0.01:0.2;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d,c,'--k');hold on;
		D = 0.3;
		c = 0.0:0.01:0.3;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d,c,'--k');hold on;
		D = 0.4;
		c = 0.0:0.01:0.4;
		d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
		plot(d,c,'--k');hold on;
		
		for(i=1:4) %for each input sharpness
			for(j=1:4) %for each input contrast
				%draw an arrow from the true sharpness/contrast to the average perceived sharpness/contrast
				diff_sharpness = avg_data_d(i,j,s) - true_d(i);
				diff_contrast = avg_data_c(i,j,s) - true_c(j);
				quiver(true_d(i),true_c(j),diff_sharpness,diff_contrast,0,'LineWidth',1,'Color',[0 0 0],'MaxHeadSize',0.4);hold on;
				
				c_curr = true_c(j) + c_origin;
				d_curr = true_d(i) + d_origin;
				
				%draw an arrow from the true sharpness/contrast to the predicted sharpness/contrast
				c_predicted = 0;
				d_predicted = 0;
				
				if(fit_order==1)
					%c_predicted = mapping_c(3,s)*c_curr + mapping_c(2,s)*d_curr + mapping_c(1,s);
					%d_predicted = mapping_d(3,s)*c_curr + mapping_d(2,s)*d_curr + mapping_d(1,s);
					x = [c_curr d_curr];
					M_curr(:,:) = M(s,:,:);
					u_curr = u(s,:);
					y = M_curr*x' + u_curr';
					c_predicted = y(1);
					d_predicted = y(2);
				else
					ind_poly = 0;
					for(m=1:fit_order+1)
						for(n=1:fit_order+1-(m-1))
							ind_poly = ind_poly+1;
							c_predicted = c_predicted + mapping_c(ind_poly, s) * ( (c_curr^(m-1)) * (d_curr^(n-1)) );
							d_predicted = d_predicted + mapping_d(ind_poly, s) * ( (c_curr^(m-1)) * (d_curr^(n-1)) );
						end
					end
				end
				
				
				%diff_sharpness = d_predicted;
				%diff_contrast = c_predicted;
				
				diff_sharpness = d_predicted - d_curr;
				diff_contrast = c_predicted - c_curr;
				
				%quiver(true_d(i),true_c(j),diff_sharpness,diff_contrast,0,'LineWidth',1,'Color',[1 0 0],'MaxHeadSize',0.4);hold on;
				
				%residual
				c_curr = avg_data_c(i,j,s) + c_origin;
				d_curr = avg_data_d(i,j,s) + d_origin;
				diff_sharpness = d_curr - d_predicted;
				diff_contrast = c_curr - c_predicted;
				
				res = res + sqrt(diff_sharpness*diff_sharpness+diff_contrast*diff_contrast);
				nbRes = nbRes+1;
				
				quiver(true_d(i),true_c(j),diff_sharpness,diff_contrast,0,'LineWidth',1,'Color',[1 0 0],'MaxHeadSize',0.4);hold on;
			end
		end
	
		%--- axis and label ---%
		axis equal;
		axis([0 0.3 0. 0.3]);
		xlabel('Perceptual sharpness d');
		ylabel('Perceptual contrast c');
		stitle = sprintf('Mapping between material parameters and perception\n Brush size = %d',(s-1)*4);
		title(stitle);
		
		filename = sprintf('estimated_mapping_known_order%d_brush%d.pdf',fit_order,(s-1)*4);
		%saveas(figMap,filename);
		
		%--- Plot backward mapping ---
		if(fit_order==1)
			figMap = figure();
			%--- iso-lines ---%
			D = 0.1;
			c = 0.0:0.01:0.1;
			d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
			plot(d,c,'--k');hold on;
			D = 0.2;
			c = 0.0:0.01:0.2;
			d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
			plot(d,c,'--k');hold on;
			D = 0.3;
			c = 0.0:0.01:0.3;
			d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
			plot(d,c,'--k');hold on;
			D = 0.4;
			c = 0.0:0.01:0.4;
			d = sqrt( (D.*D-c.*c)./(1.78*1.78) );
			plot(d,c,'--k');hold on;
		
			for(i=1:4) %for each input sharpness
				for(j=1:4) %for each input contrast
				
					%draw an arrow from the true sharpness/contrast to the average perceived sharpness/contrast
					diff_sharpness = avg_data_d(i,j,s) - true_d(i);
					diff_contrast = avg_data_c(i,j,s) - true_c(j);
					quiver(true_d(i),true_c(j),diff_sharpness,diff_contrast,0,'LineWidth',1,'Color',[0 0 0],'MaxHeadSize',0.4);hold on;
						
					%draw an arrow from the average perceived sharpness/contrast to the estimated input material
					c_curr = avg_data_c(i,j,s) + c_origin;
					d_curr = avg_data_d(i,j,s) + d_origin;
					%c_predicted = ( mapping_d(2,s)*c_curr - mapping_c(2,s)*d_curr - mapping_d(2,s)*mapping_c(1,s) + mapping_c(2,s)*mapping_d(1,s) )/...
					%					( mapping_d(2,s)*mapping_c(3,s) - mapping_c(2,s)*mapping_d(3,s) );
					
										
					%d_predicted = ( mapping_d(3,s)*c_curr - mapping_c(3,s)*d_curr - mapping_d(3,s)*mapping_c(1,s) + mapping_c(3,s)*mapping_d(1,s) )/...
					%					( mapping_d(3,s)*mapping_c(2,s) - mapping_c(3,s)*mapping_d(2,s) );
					
					
					x = [c_curr d_curr];
					Minv_curr(:,:) = Minv(s,:,:);
					u_curr = u(s,:);
					y = Minv_curr*(x - u_curr)';
					c_predicted = y(1);
					d_predicted = y(2);
										
					diff_sharpness = d_predicted - d_curr;
					diff_contrast = c_predicted - c_curr;
					quiver(avg_data_d(i,j,s),avg_data_c(i,j,s),diff_sharpness,diff_contrast,0,'LineWidth',1,'Color',[0 1 0],'MaxHeadSize',0.4);hold on;
					
					
					%residual
					c_curr = true_c(j) + c_origin;
					d_curr = true_d(i) + d_origin;
					diff_sharpness = d_curr - d_predicted;
					diff_contrast = c_curr - c_predicted;
				
					%quiver(avg_data_d(i,j,s),avg_data_c(i,j,s),diff_sharpness,diff_contrast,0,'LineWidth',1,'Color',[0 1 0],'MaxHeadSize',0.4);hold on;
				end
			end
		end
		
		%--- axis and label ---%
		axis equal;
		axis([0 0.3 0. 0.3]);
		xlabel('Perceptual sharpness d');
		ylabel('Perceptual contrast c');
		stitle = sprintf('Mapping between perceived gloss and true gloss\n Brush size = %d',(s-1)*4);
		title(stitle);
		
		filename = sprintf('estimated_inverse_residual_known_order%d_brush%d.pdf',fit_order,(s-1)*4);
		%saveas(figMap,filename);
		
	end
	
	% L2 distance between prediction and mean setting
	res = res/nbRes;
	res

	% R2
	r2_c = 1.-error_c/sstot_c;
	r2_c
	r2_d = 1.-error_d/sstot_d;
	r2_d

	% standard error of estimate
	error_c = sqrt(error_c/sData(1));
	error_c
	error_d = sqrt(error_d/sData(1));
	error_d